'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; //eslint-disable-next-line


var _language = require('./language');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var flagsMap = {
  global: 'g',
  ignoreCase: 'i',
  multiline: 'm',
  unicode: 'u',
  sticky: 'y'
};

var getFlags = function getFlags(flags) {
  var result = '';
  if (typeof flags === 'string') {
    result = flags;
  } else if ((typeof flags === 'undefined' ? 'undefined' : _typeof(flags)) === 'object') {
    Object.keys(flagsMap).forEach(function (x) {
      if (flags[x]) {
        result += flagsMap[x];
      }
    });
  }
  return result;
};

var NaturalRegex = function NaturalRegex() {
  _classCallCheck(this, NaturalRegex);
};

NaturalRegex.parser = _language.parser;

NaturalRegex.parse = function (code) {
  return NaturalRegex.parser.parse(code);
};

NaturalRegex.from = function (code, flags) {
  return new RegExp(NaturalRegex.parse(code), getFlags(flags));
};

NaturalRegex.replace = function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$string = _ref.string,
      string = _ref$string === undefined ? '' : _ref$string,
      _ref$match = _ref.match,
      match = _ref$match === undefined ? '' : _ref$match,
      _ref$replace = _ref.replace,
      replace = _ref$replace === undefined ? '' : _ref$replace,
      _ref$flags = _ref.flags,
      flags = _ref$flags === undefined ? 'g' : _ref$flags;

  return string.replace(NaturalRegex.from(match, flags), replace);
};

exports['default'] = NaturalRegex;